/***************************************************************************
                          confdialog.h  -  description
                             -------------------
    begin                : Sun Jan 27 2002
    copyright            : (C) 2002 by Dominik Seichter
    email                : domseichter@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFDIALOG_H
#define CONFDIALOG_H

// QT includes
#include <qcheckbox.h>

// KDE includes
#include <kdialogbase.h>
#include <knuminput.h>
#include <kio/jobclasses.h>

class QRadioButton;
class QHBoxLayout;
class QVBoxLayout;
class QWidget;
class KIO::Job;
class ConfDialog : public KDialogBase {
    Q_OBJECT
    public:
        ConfDialog( QWidget* parent = 0, const char* name = 0 );
        ~ConfDialog();

        bool loadplugins() { return checkPlugins->isChecked(); }
        bool ask() { return checkAsk->isChecked(); }
        bool dir() { return checkDir->isChecked(); }
        bool hiddendir() { return checkHiddenDir->isChecked(); }
        int thumbSize() { return spinSize->value(); }
        bool autosize() { return checkAutosize->isChecked(); }
        int historyItems() { return spinHistory->value(); }
        bool useWizard();
        
        void setLoadPlugins( bool b ) { checkPlugins->setChecked( b ); }
        void setAsk( bool b ) { checkAsk->setChecked( b ); }
        void setDir( bool b ) { checkDir->setChecked( b ); }
        void setHiddenDir( bool b ) { checkHiddenDir->setChecked( b ); }
        void setThumbSize( int b ) { spinSize->setValue( b ); }
        void setAutosize( bool b ) { checkAutosize->setChecked( b ); }
        void setHistoryItems( int b ) { spinHistory->setValue( b ); }
        void setUseWizard( bool b );
        
        QRadioButton* optionFirstDot;
        QRadioButton* optionLastDot;
        QRadioButton* optionCustomDot;
        KIntNumInput* spinDot;

    public slots:
        void enableControls();
                        
    private slots:
        void changeService(bool b);
        void defaults();

        void copied( KIO::Job* job );
                
    private:
        void setupTab1();
        void setupTab2();
        void setupTab3();

        void installServiceEntry();
        void removeServiceEntry();
        bool serviceEntryInstalled();
                        
    protected:
        QCheckBox* checkContext;
        QCheckBox* checkAsk;
        QCheckBox* checkDir;
        QCheckBox* checkHiddenDir;
        QCheckBox* checkPlugins;
        QCheckBox* checkAutosize;

        QRadioButton* optionWizard;
        QRadioButton* optionTabs;
        
        KIntNumInput* spinSize;
        KIntNumInput* spinHistory;
};

#endif
