/***************************************************************************
                          fileplugin.h  -  description
                             -------------------
    begin                : Mon Jul 1 2002
    copyright            : (C) 2002 by Dominik Seichter
    email                : domseichter@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FILEPLUGIN_H
#define FILEPLUGIN_H

#include "batchrenamer.h"
#include "pluginloader.h"
#include "plugin.h"
#include "helpdialog.h"
#include <kdialogbase.h>

#include <vector>

class KFileMetaInfoProvider;
class KFileMimeTypeInfo;
class KPushButton;
class KService;
class QLabel;
class QWidget;
class QVBoxLayout;
class KFilePlugin;
class FilePlugin : public Plugin  {
    Q_OBJECT
    public:
        FilePlugin( KService* service );
        ~FilePlugin();

        bool isValid() {
            return keys.count() > 0 ? true : false;
        };

        QString getName();
        QString getAccelName();
        int type();

        bool checkError();
        void drawInterface( QWidget* w, QVBoxLayout* l );
        void fillStructure();
        QString processFile( values* val, int i, QString token, int mode );
        void finished();

        void addHelp( HelpDialog* combo );
        void removeHelp(  HelpDialog* combo );

        void setUsed( bool m );
        const QPixmap getIcon() const;
        
    private slots:
        void changeMetaInfo();

    protected:
        QMap<QString,QString> map; // key, value

        KFilePlugin* fileplugin;

        KPushButton* buttonWrite;

        QString name, comment, icon, mimetype;

        QStringList keys;
        QStringList groups;
        KFileMetaInfoProvider* mip;
};

class QCheckBox;
class QScrollView;
class KLineEdit;
class MetaInfoDialog: public KDialogBase {
    Q_OBJECT
    public:
        MetaInfoDialog( QWidget* parent = 0 );
        ~MetaInfoDialog();

        void setKeys( QStringList* k, KFilePlugin* p, QString mimetype );

        // no clean implementation
        // access them trogh member functions
        std::vector <QCheckBox*> check;
        std::vector <KLineEdit*> value;
        std::vector <QLabel*> label;
    public slots:
        void enableLineEdits();

    protected:
        QScrollView* view;
};
#endif
