/***************************************************************************
                          wizard.cpp  -  description
                             -------------------
    begin                : Die Mai 15 15:34:19 CEST 2001
    copyright            : (C) 2001 by Dominik Seichter
    email                : domseichter@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Own includes
#include "wizard.h"
#include "krenameimpl.h"

// KDE includes
#include <kapplication.h>
#include <kiconloader.h>
#include <klocale.h>
#include <kmenubar.h>
#include <kmessagebox.h>
#include <kpushbutton.h>
#include <kstartupinfo.h>

// Qt includes
#include <qlabel.h>
#include <qlayout.h>

wizard::wizard( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : KWizard( parent, name, modal, fl )
{
    setCaption( "Krename" ); // "Krename by Dominik Seichter
    setIcon( BarIcon( "krename" ) );
    setTitleFont( QFont( "Helvetica", 0 ) );

    menuBar = new KMenuBar(this);

    krename = new KRenameImpl( this, menuBar, this->finishButton() );
    krename->setTitle( true );
    connect( krename, SIGNAL( pageDone( QWidget*, const QString & ) ), this, SLOT( slotAddPage( QWidget*, const QString & ) ) );
    connect( krename, SIGNAL( showPage( int ) ), this, SLOT( slotShowPage( int ) ) );
    connect( krename, SIGNAL( enableFinish( bool ) ), this, SLOT( slotEnableFinish( bool ) ) );
    krename->setup();
    
    // Tell KStartupInfo that KRename has been loaded completly
    KStartupInfoId id;
    id.initId( kapp->startupId() );
    KStartupInfo::sendFinish( id );
}

wizard::~wizard()
{
}

void wizard::slotAddPage( QWidget* page, const QString & title )
{
    addPage( page, title );
}

void wizard::slotShowPage( int page )
{
    showPage( this->page( page - 1 ) );
}

void wizard::slotEnableFinish( bool b )
{
    setFinishEnabled( page( pageCount() - 1), b );
}

void wizard::closeEvent( QCloseEvent* e )
{
    if( krename->askOnExit() )
        if( KMessageBox::questionYesNo( this, i18n("Do you really want to quit Krename ?") ) == KMessageBox::Yes ) {
            e->accept();
        } else
            e->ignore();
    else
        e->accept();
}

void wizard::accept()
{ /* Do nothing */ }

void wizard::reject()
{
    this->close();
}




